/* Copyright 2015-2017 Research Foundation State University of New York   */

/* This file is part of QUB Online.                                       */

/* QUB Online is free software; you can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation, either version 3 of the License, or      */
/* (at your option) any later version.                                    */

/* QUB Online is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License,     */
/* named LICENSE.txt, in the QUB Online program directory.  If not, see  */
/* <http://www.gnu.org/licenses/>.                                        */

#ifndef QUBX_IDEALIZE_MDL_H
#define QUBX_IDEALIZE_MDL_H

#include "qubfast.h"

#ifdef __cplusplus
extern "C" {
#endif

QUBFAST_API void* qubx_idealize_mdl32_context_create();
QUBFAST_API void qubx_idealize_mdl32_context_free(void *ctx);

QUBFAST_API void* qubx_idealizer_mdl32_create(void *ctx);
QUBFAST_API void qubx_idealizer_mdl32_free(void *idlz);
  
QUBFAST_API int qubx_idealizer_mdl32_idealize(void *idlz, float *data, int N, int Lmin, int split3, int combineClose, float combineDelta); // returns dwell count
QUBFAST_API void qubx_idealizer_mdl32_interrupt(void *idlz);

  // split3: nonzero to also try splitting intervals at two breakpoints before giving up (slower)
QUBFAST_API int qubx_idealizer_mdl32_get_dwells(void *idlz, int *counts, float *amps, float *stds, int capacity);
QUBFAST_API int qubx_idealizer_mdl32_get_dwells_fl(void *idlz, int first_index, int *ff, int *ll, float *amps, float *stds, int capacity);

#ifdef __cplusplus
}
#endif

#endif
